<?php
namespace Vitrium\Drm\HttpClient;

class CurlOptions {
    const TIMEOUT = 15;
    const VERIFY_SSL = true;

    // Private array with public getter
    protected $options;

    public function __construct($options) {
        $this->options = $options;
    }

    // Public standard cUrl options getters; returning default values if not set up
    public function getVerifySsl() {
        return isset($this->options['verify_ssl']) ? (bool) $this->options['verify_ssl'] : self::VERIFY_SSL;
    }
    public function getTimeout() {
        return isset($this->options['timeout']) ? (int) $this->options['timeout'] : self::TIMEOUT;
    }
    public function getUserAgent() {
        return isset($this->options['user_agent']) ? $this->options['user_agent'] : self::USER_AGENT;
    }
    public function getFollowRedirects() {
        return isset($this->options['follow_redirects']) ? (bool) $this->options['follow_redirects'] : false;
    }

    // Custom settings public getters and setters

    // If async_download_target is set, the response is saved to this file (used for PDF downloads) and the async_download_target is returned instead of the response
    public function getAsyncDownloadTarget() {
        return isset($this->options['async_download_target']) ? $this->options['async_download_target'] : '';
    }
    public function setAsyncDownloadTarget($value) {
        return $this->options['async_download_target'] = $value;
    }
}
