<?php
namespace Vitrium\Drm\HttpClient;

class HttpClientException extends \Exception {
    // Private readonly fields with public getters
    private $request;
    private $response;

    /**
    * Initialize exception.
    *
    * @param string       $message  Error message.
    * @param int          $code     Error code.
    * @param HttpRequest  $request  Request data.
    * @param HttpResponse $response Response data.
    */
    public function __construct($message, $code, HttpRequest $request, HttpResponse $response) {
        parent::__construct($message, $code);

        $this->request  = $request;
        $this->response = $response;
    }

    // Property getters
    public function getRequest() {
        return $this->request;
    }
    public function getResponse() {
        return $this->response;
    }
}
