<?php
namespace Vitrium\Drm\HttpClient;

class HttpRequest {
    // Private fields. These are readonly and need to be initialized in the contructor call.
    private $url;
    private $method;
    private $parameters;
    private $headers;
    private $body;

    /**
    * Initialize request.
    *
    * @param string $url        Request url.
    * @param string $method     Request method.
    * @param array  $parameters Request paramenters.
    * @param array  $headers    Request headers.
    * @param string $body       Request body.
    */
    public function __construct($url = '', $method = 'POST', $parameters = [], $headers = [], $body = '') {
        $this->url        = $url;
        $this->method     = $method;
        $this->parameters = $parameters;
        $this->headers    = $headers;
        $this->body       = $body;
    }

    // Property getters
    public function getUrl() {
        return $this->url;
    }
    public function getMethod() {
        return $this->method;
    }
    public function getParameters() {
        return $this->parameters;
    }
    public function getHeaders() {
        return $this->headers;
    }
    public function getRawHeaders() {
        $headers = [];

        foreach ($this->headers as $key => $value) {
            $headers[] = $key . ': ' . $value;
        }

        return $headers;
    }
    public function getBody() {
        return $this->body;
    }
}
