<?php
namespace Vitrium\Drm\VitriumClasses;

// Class used for Vitrium content upload settings
class DocPostContext implements \JsonSerializable {
    private $folderId;   // Vitrium folder GUID ID
    private $policyId;   // Vitrium content setting GUID ID
    private $filename;   // Vitrium content file name
    private $title;      // Vitrium content title
    private $skipPages;  // Content page numbers that should not be protected with Vitrium DRM
    private $externalKey; // Vitrium content external key (normally a third-party ID)
    private $versionName; // Vitrium content version name
    private $enableVersionNotification; // True to enable user notification when new version of content is created

    // Property getters/setters
    public function getFolderId() {
        return $this->folderId;
    }
    public function getPolicyId() {
        return $this->policyId;
    }
    public function getFileName() {
        return $this->filename;
    }
    public function getTitle() {
        return $this->title;
    }
    public function getSkipPages() {
        return $this->skipPages;
    }
    public function getExternalKey() {
        return $this->externalKey;
    }
    public function getVersionName() {
        return $this->versionName;
    }
    public function getEnableVersionNotification() {
        return $this->enableVersionNotification;
    }
    public function setFolderId($folderId) {
        // TODO: Verify GUID format
        $this->folderId = $folderId;
    }
    public function setPolicyId($policyId) {
        // TODO: Verify GUID format
        $this->policyId = $policyId;
    }
    public function setFileName($filename) {
        $this->filename = $filename;
    }
    public function setTitle($title) {
        $this->title = $title;
    }
    public function setSkipPages($skipPages) {
        // TODO: Verify format - should be comma-separated integers
        return $this->skipPages;
    }
    public function setExternalKey($externalKey) {
        $this->externalKey = $externalKey;
    }
    public function setVersionName($versionname) {
        $this->versionName = $versionname;
    }
    public function setEnableVersionNotification($enable) {
        $this->enableVersionNotification = $enable;
    }

    public function jsonSerialize() {
        return [
            'FolderId' => $this->folderId,
            'PolicyId' => $this->policyId,
            'FileName' => $this->filename,
            'Title' => $this->title,
            'SkipPages' => $this->skipPages,
            'ExternalKey' => $this->externalKey,
            'VersionName' => $this->versionName,
            'EnableVersionNotification' => $this->enableVersionNotification
        ];
    }
}
