<?php
namespace Vitrium\Drm\VitriumClasses;

// Class encapsulating VItrium Document Version information
class DocumentVersion implements \JsonSerializable {
    private $id;     // GUID ID
    private $docId;  // Parent Vitrium Document GUID ID
    private $docCode;  // Parent Vitrium Document Doc Code string
    private $webViewerUrl;   // Vitrium Web Viewer URL of this Document Version

    // Property getters/setters
    public function getId() {
        return $this->id;
    }
    public function getDocId() {
        return $this->docId;
    }
    public function getDocCode() {
        return $this->docCode;
    }
    public function getUrl() {
        return $this->webViewerUrl;
    }
    public function setId($id) {
        $this->id = $id;
    }
    public function setDocId($docId) {
        $this->docId = $docId;
    }
    public function setDocCode($docCode) {
        $this->docCode = $docCode;
    }
    public function setUrl($url) {
        $this->webViewerUrl = $url;
    }

    /**
    * Create an instance of the DocumentVersion class.
    *
    * @param StdClass $object Optional object as retrieved from a Vitrium API call.
    */
    public function __construct($object = null) {
        $this->setId((isset($object) && is_object($object) && property_exists($object, 'Id')) ? $object->Id : '');
        $this->setDocId((isset($object) && is_object($object) && property_exists($object, 'DocumentId')) ? $object->DocumentId : '');
        $this->setDocCode((isset($object) && is_object($object) && property_exists($object, 'DocCode')) ? $object->DocCode : '');
        $this->setUrl((isset($object) && is_object($object) && property_exists($object, 'WebViewerUrl')) ? $object->WebViewerUrl : '');
    }

    public function jsonSerialize() {
        return [
            'Id' => $this->id,
            'DocumentId' => $this->docId,
            'DocCode' => $this->docCode,
            'WebViewerUrl' => $this->webViewerUrl
        ];
    }
}
